summaryrefslogtreecommitdiffstats
path: root/mirroring/test-mirrors.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-07 18:45:59 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-07 18:45:59 +0000
commit19fcec84d8d7d21e796c7624e521b60d28ee21ed (patch)
tree42d26aa27d1e3f7c0b8bd3fd14e7d7082f5008dc /mirroring/test-mirrors.sh
parentInitial commit. (diff)
downloadceph-upstream.tar.xz
ceph-upstream.zip
Adding upstream version 16.2.11+ds.upstream/16.2.11+dsupstream
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'mirroring/test-mirrors.sh')
-rwxr-xr-xmirroring/test-mirrors.sh69
1 files changed, 69 insertions, 0 deletions
diff --git a/mirroring/test-mirrors.sh b/mirroring/test-mirrors.sh
new file mode 100755
index 000000000..280118bc8
--- /dev/null
+++ b/mirroring/test-mirrors.sh
@@ -0,0 +1,69 @@
+#!/usr/bin/env bash
+#
+# Simple script which performs a HTTP and rsync check on
+# all Ceph mirrors over IPv4 and IPv6 to see if they are online
+#
+# Requires IPv4, IPv6, rsync and curl
+#
+# Example usage:
+# - ./test-mirrors.sh eu.ceph.com,de.ceph.com,hk.ceph.com
+# - cat MIRRORS |cut -d ':' -f 1|xargs -n 1 ./test-mirrors.sh
+#
+
+function print_usage {
+ echo "Usage: $0 mirror1,mirror2,mirror3,mirror4,etc"
+}
+
+function test_http {
+ HOST=$1
+
+ echo -n "$HOST HTTP IPv4: "
+ curl -s -I -4 -o /dev/null http://$HOST
+ if [ "$?" -ne 0 ]; then
+ echo "FAIL"
+ else
+ echo "OK"
+ fi
+
+ echo -n "$HOST HTTP IPv6: "
+ curl -s -I -6 -o /dev/null http://$HOST
+ if [ "$?" -ne 0 ]; then
+ echo "FAIL"
+ else
+ echo "OK"
+ fi
+}
+
+function test_rsync {
+ HOST=$1
+
+ echo -n "$HOST RSYNC IPv4: "
+ rsync -4 -avrqn ${HOST}::ceph /tmp 2>/dev/null
+ if [ "$?" -ne 0 ]; then
+ echo "FAIL"
+ else
+ echo "OK"
+ fi
+
+ echo -n "$HOST RSYNC IPv6: "
+ rsync -6 -avrqn ${HOST}::ceph /tmp 2>/dev/null
+ if [ "$?" -ne 0 ]; then
+ echo "FAIL"
+ else
+ echo "OK"
+ fi
+}
+
+MIRRORS=$1
+
+if [ -z "$MIRRORS" ]; then
+ print_usage
+ exit 1
+fi
+
+IFS=', ' read -r -a array <<< "$MIRRORS"
+
+for MIRROR in "${array[@]}"; do
+ test_http $MIRROR
+ test_rsync $MIRROR
+done